// Copyright (C) 2003 by ASUSTeK. All rights are reserved.

function remap_currval (id, val, functype)
{
    if (functype == ASWM_FNTYPE_CV || functype == ASWM_FNTYPE_NONE) {
        return '';
    }

    if (parent.tblSeqResources[id]) {
        if (parent.tblSeqResources[id][val]) {
            return parent.tblSeqResources[id][val];
        }
    }
    if (parent.tblBtfResources[id]) {
        return '';
    }

    return val;
}

function normalizeGID (gid)
{
    var curr = gid;

    if ((curr >> 16) == parent.asID['ASWM_SNRGROUP_DISKS'] ||
        (curr >> 16) == parent.asID['ASWM_SNRGROUP_DISK']) {
        curr = parent.asID['ASWM_SNRGROUP_DISKS'] << 16;
    }

    if ((curr >> 16) == parent.asID['ASWM_SNRGROUP_POWERS'] ||
        (curr >> 16) == parent.asID['ASWM_SNRGROUP_POWERMODULE']) {
        curr = parent.asID['ASWM_SNRGROUP_POWERS'] << 16;
    }
    return curr;
}

function normalizeLabeledGID (gid)
{
    var curr = gid;

    if ((curr >> 16) == parent.asID['ASWM_SNRGROUP_DISKS'] ||
        (curr >> 16) == parent.asID['ASWM_SNRGROUP_DISK']) {
        curr = parent.asID['ASWM_SNRGROUP_DISKS'] << 16;
    }

    if ((curr >> 16) == parent.asID['ASWM_SNRGROUP_POWERS'] ||
        (curr >> 16) == parent.asID['ASWM_SNRGROUP_POWERMODULE']) {
        curr = parent.asID['ASWM_SNRGROUP_POWERS'] << 16;
    }

    return parent.__grpLabelPrefix__ + ((curr >> 16).toString(16).length < 4 ? '0' + (curr >> 16).toString(16): (curr >> 16).toString(16));
}

function switchHealthSignState (flag)
{
    for (i = 0; i < parent.once.GSensors.length(); i++) {
        var snsr = parent.once.GSensors.at(i);

        if (!parent.once.theHealthMenu.idAt(normalizeLabeledGID(normalizeGID(snsr.gid)))) {
            continue;
        }
        if (document.images['isnsr' + i])
            if (flag) {
                document.images['isnsr' + i].src = getSnsrHealthSign(snsr.currstatus);
            } else {
                document.images['isnsr' + i].src = "./img/z/i-blank.gif";
            }
    }
}

function once (ignored)
{
    var last = 0, k = 0, i, j = '';

    if (__onceCalled__ && !ignored) {
        if (divSTWatch) {
            divSTWatch.style.visibility = 'hidden';
        }
        return;
    }

    __onceCalled__ = true;

    lastGSensorNumber = parent.once.GSensors.length();

    for (i = 0; i < parent.once.GSensors.length(); i++, last = curr) {
        var snsr = parent.once.GSensors.at(i);
        var curr = normalizeGID(snsr.gid);
        var curs = normalizeLabeledGID(curr);

        if (!parent.once.theHealthMenu.idAt(curs)) {
            continue;
        }
        if (curr != last) {
            if (last != 0) {
                if (k == 0) {
                    j +=
'                <TD WIDTH="20" rowspan="2" valign="bottom"><img src="./img/z/group_09.gif"></TD></TR>' +
'            <TR height="1">' +
'                <TD WIDTH="191" height="1" colspan="2" bgcolor="#a7a7a7"><IMG SRC="./img/z/group_07.gif" BORDER="0" ></TD>' +
'                <TD WIDTH="362" height="1" colspan="6" bgcolor="#a7a7a7"><img src="./img/z/bg.gif"></TD></TR>' +
'            <TR height="22">' +
'                <TD WIDTH="191" height="22" colspan="2" bgcolor="#DBDBDB"><IMG SRC="./img/z/group_left.gif" BORDER="0" ></TD>' +
'                <TD WIDTH="382" height="22" colspan="7" bgcolor="#DBDBDB"><img src="./img/z/bg.gif"></TD></TR></TABLE>';

                } else {
                    j +=
'            </TR>' +
'            <TR height="1">' +
'                <TD WIDTH="1" bgcolor="#A7A7A7"></TD>' +
'                <TD WIDTH="190" height="1" colspan="2" bgcolor="#a7a7a7"></TD>' +
'                <TD WIDTH="362" height="1" colspan="6" bgcolor="#a7a7a7"><img src="./img/z/bg.gif"></TD>' +
'                <TD WIDTH="20" rowspan="2"><IMG SRC="./img/z/group_right.gif" BORDER="0" ></TD></TR>' +
'            <TR height="22">' +
'                <TD WIDTH="191" height="22" colspan="3" bgcolor="#DBDBDB"></TD>' +
'                <TD WIDTH="362" height="22" colspan="6" bgcolor="#DBDBDB"><img src="./img/z/bg.gif"></TD></TR></TABLE>';

                }

                if (k == 0) {
                    k = 1;
                } else {
                    k = 0;
                }

            }

            if (k == 0) {
                if (last == 0) {
                    j +=
'<TABLE BGCOLOR="#DBDBDB" WIDTH="573" BORDER="0" CELLPADDING="0" CELLSPACING="0">' +
'<TR height="26">' +
'    <TD><TABLE WIDTH="100%" BORDER="0" CELLPADDING="0" CELLSPACING="0">' +
'        <TR><TD WIDTH="20"><IMG SRC="./img/z/group_01.gif" BORDER="0" ></TD>' +
'            <TD WIDTH="234" background="./img/z/group_02bg.gif" align="center" class=t10b_blue>' + parent.once.theHealthMenu.idAt(curs).title + '</TD>' +
'            <TD WIDTH="20"><IMG SRC="./img/z/group_03.gif" BORDER="0" ></TD>' +
'            <TD WIDTH="298"></TD>' +
'            <TD WIDTH="1"></TD></TR></TABLE></TD></TR>';
                } else {
                    j +=
'<TABLE BGCOLOR="#DBDBDB" WIDTH="573" BORDER="0" CELLPADDING="0" CELLSPACING="0">' +
'<TR height="26">' +
'    <TD><TABLE WIDTH="100%" BORDER="0" CELLPADDING="0" CELLSPACING="0">' +
'        <TR><TD WIDTH="20"><IMG SRC="./img/z/group_01.gif" BORDER="0" ></TD>' +
'            <TD WIDTH="234" background="./img/z/group_02bg.gif" align="center" class=t10b_blue>' + parent.once.theHealthMenu.idAt(curs).title + '</TD>' +
'            <TD WIDTH="20"><IMG SRC="./img/z/group_03.gif" BORDER="0" ></TD>' +
'            <TD WIDTH="298"></TD>' +
'            <TD WIDTH="1" bgcolor="#A7A7A7"></TD></TR></TABLE></TD></TR>';

                }
                j +=

'<TR><TD><TABLE WIDTH="573" BORDER="0" CELLPADDING="0" CELLSPACING="0">' +
'            <TR height="20">' +
'                <TD WIDTH="191" colspan="2" background="./img/z/group_04bg.gif" align="center" class="t8b">' + parent.I18N['NAME'] + '</TD>' +
'                <TD WIDTH="1" bgcolor="#A7A7A7"></TD>' +
'                <TD WIDTH="47" background="./img/z/group_04bg.gif" align="center" class="t8b">' + parent.I18N['VALUE'] + '</TD>' +
'                <TD WIDTH="1" bgcolor="#A7A7A7"></TD>' +
'                <TD WIDTH="33" background="./img/z/group_04bg.gif" align="center"></TD>' +
'                <TD WIDTH="1" bgcolor="#A7A7A7"></TD>' +
'                <TD WIDTH="279" background="./img/z/group_04bg.gif" align="center" class="t8b">' + parent.I18N['DESCRIPTION'] + '</TD>' +
'                <TD WIDTH="20"><IMG SRC="./img/z/group_05.gif" BORDER="0" ></TD></TR>';

            } else {
                j +=
'<TABLE BGCOLOR="#DBDBDB" WIDTH="573" BORDER="0" CELLPADDING="0" CELLSPACING="0">' +
'<TR height="26">' +
'    <TD><TABLE WIDTH="274" BORDER="0" CELLPADDING="0" CELLSPACING="0">' +
'        <TR><TD WIDTH="20"><IMG SRC="./img/z/group_01a.gif" BORDER="0" ></TD>' +
'            <TD WIDTH="234" background="./img/z/group_02bg.gif" align="center" class=t10b_blue>' + parent.once.theHealthMenu.idAt(curs).title + '</TD>' +
'            <TD WIDTH="20"><IMG SRC="./img/z/group_03.gif" BORDER="0" ></TD></TR></TABLE></TD></TR>' +
'<TR><TD><TABLE WIDTH="573" BORDER="0" CELLPADDING="0" CELLSPACING="0">' +
'            <TR height="20">' +
'                <TD WIDTH="1" bgcolor="#A7A7A7"></TD>' +
'                <TD WIDTH="190" colspan="2" background="./img/z/group_04bg.gif" align="center" class="t8b">' + parent.I18N['NAME'] + '</TD>' +
'                <TD WIDTH="1" bgcolor="#A7A7A7"></TD>' +
'                <TD WIDTH="47" background="./img/z/group_04bg.gif" align="center" class="t8b">' + parent.I18N['VALUE'] + '</TD>' +
'                <TD WIDTH="1" bgcolor="#A7A7A7"></TD>' +
'                <TD WIDTH="33" background="./img/z/group_04bg.gif" align="center"></TD>' +
'                <TD WIDTH="1" bgcolor="#A7A7A7"></TD>' +
'                <TD WIDTH="279" background="./img/z/group_04bg.gif" align="center" class="t8b">' + parent.I18N['DESCRIPTION'] + '</TD>' +
'                <TD WIDTH="20" background="./img/z/group_04bg.gif"></TD></TR>';

            }

        } else {

            if (k == 0) {
                j +=
'                <TD WIDTH="20" background="./img/z/group_06bg.gif"></TD></TR>' +
'            <TR><TD WIDTH="553" colspan="8" background="./img/z/form_line.gif"></TD>' +
'                <TD WIDTH="20" background="./img/z/group_06bg.gif"></TD></TR>';

            } else {
                j +=
'            <TR><TD WIDTH="573" colspan="10" background="./img/z/form_line.gif"></TD></TR>';

            }

        }

        if (k == 0) {
            j +=
'            <TR height="20">' +
'                <TD WIDTH="191" colspan="2" background="./img/z/form_bgcolor2c.gif" class=t8_blue>' +
'                            <TABLE WIDTH="100%" BORDER="0" CELLPADDING="0" CELLSPACING="3">' +
'                            <TR><TD WIDTH="22"><IMG name="isnsr' + i + '" SRC="./img/z/i-blank.gif" BORDER="0" ></TD>' +
'                                <TD>' + snsr.internalname + '</TD></TR></TABLE></TD>' +
'                <TD WIDTH="1" bgcolor="#D0D0D0"></TD>' +
'                <TD WIDTH="47" bgcolor="#F2f2f2" align="right" class=t8_blue><span id="snsr' + i + '">' + remap_currval(snsr.id, snsr.currvalue, snsr.functype) + '</span>&nbsp;</TD>' +
'                <TD WIDTH="1" bgcolor="#D0D0D0"></TD>' +
'                <TD WIDTH="33" bgcolor="#F2f2f2" align="center" class=t8_blue>' + (parent.once.GResUnit[snsr.unit] ? parent.once.GResUnit[snsr.unit] : '') + '</TD>' +
'                <TD WIDTH="1" bgcolor="#D0D0D0"></TD>' +
'                <TD WIDTH="279" bgcolor="#F2f2f2"><TABLE WIDTH="100%" BORDER="0" CELLPADDING="0" CELLSPACING="3"><TR><TD class=t8_blue><span id="snsrdesc' + i + '"></span></TD></TR></TABLE></TD>';

        } else {
            j +=
'            <TR height="20">' +
'                <TD WIDTH="1" bgcolor="#A7A7A7"></TD>' +
'                <TD WIDTH="190" colspan="2" bgcolor="#F2f2f2" class=t8_blue>' +
'                            <TABLE WIDTH="100%" BORDER="0" CELLPADDING="0" CELLSPACING="3">' +
'                            <TR><TD WIDTH="22"><IMG name="isnsr' + i + '" SRC="./img/z/i-blank.gif" BORDER="0" ></TD>' +
'                                <TD>' + snsr.internalname + '</TD></TR></TABLE></TD>' +
'                <TD WIDTH="1" bgcolor="#D0D0D0"></TD>' +
'                <TD WIDTH="47" bgcolor="#F2f2f2" align="right" class=t8_blue><span id="snsr' + i + '">' + remap_currval(snsr.id, snsr.currvalue, snsr.functype) + '</span>&nbsp;</TD>' +
'                <TD WIDTH="1" bgcolor="#D0D0D0"></TD>' +
'                <TD WIDTH="33" bgcolor="#F2f2f2" align="center" class=t8_blue>' + (parent.once.GResUnit[snsr.unit] ? parent.once.GResUnit[snsr.unit] : '') + '</TD>' +
'                <TD WIDTH="1" bgcolor="#D0D0D0"></TD>' +
'                <TD WIDTH="299" colspan="2" background="./img/z/form_bgcolor3.gif"><TABLE WIDTH="100%" BORDER="0" CELLPADDING="0" CELLSPACING="3"><TR><TD class=t8_blue background="./img/z/form_bgcolor3.gif"><span id="snsrdesc' + i + '"></span></TD></TR></TABLE></TD></TR>';
        }
    }

    if (k == 0) {
        j +=
'                <TD WIDTH="20" rowspan="2" bgcolor="#F2f2f2" valign="bottom"><img src="./img/z/group_09.gif"></TD></TR>' +
'            <TR height="1">' +
'                <TD WIDTH="191" height="1" colspan="2" bgcolor="#a7a7a7"></TD>' +
'                <TD WIDTH="362" height="1" colspan="6" bgcolor="#a7a7a7"><img src="./img/z/bg.gif"></TD></TR></TABLE>';

    } else {
        j +=
'            </TR>' +
'            <TR height="1">' +
'                <TD WIDTH="1" bgcolor="#A7A7A7"></TD>' +
'                <TD WIDTH="190" height="1" colspan="2" bgcolor="#a7a7a7"></TD>' +
'                <TD WIDTH="362" height="1" colspan="7" bgcolor="#a7a7a7"><img src="./img/z/bg.gif"></TD></TR></TABLE>';

    }

    writeHTML('overall', j);

    if (divSTWatch) {
        divSTWatch.style.visibility = 'hidden';
    }
    
    allDivsReady = true;
}

function periodical ()
{
    if (!allDivsReady)
        return;

    if (lastGSensorNumber != parent.once.GSensors.length())
        once(true);

    for (i = 0; i < parent.once.GSensors.length(); i++) {
        var snsr = parent.once.GSensors.at(i);

        if (!parent.once.theHealthMenu.idAt(normalizeLabeledGID(normalizeGID(snsr.gid)))) {
            continue;
        }

        writeHTML('snsr' + i, remap_currval(snsr.id, snsr.currvalue, snsr.functype));
        if (snsr.prevstatus != snsr.currstatus || snsr.functype == ASWM_FNTYPE_CV || snsr.functype == ASWM_FNTYPE_NONE)
            writeHTML('snsrdesc' + i, getSnsrHealthDesc2(snsr.id, snsr.currvalue, snsr.currstatus, '; '));
    }

    if (divSTWatch) {
        divSTWatch.style.visibility = 'hidden';
    }
}
